//     ======================= COM_port.h ===================================
//     **********************************************************************
//     Author: Yeremeyev Dmitriy Vladimirovich *** mailto:edvmail@mail.ru
//     Last update : 11.12.2009
//     **********************************************************************
#if !defined(COM_PORT_H_INCLUDED_)
#define COM_PORT_H_INCLUDED_

#include "wx/wx.h"

#define COMPortDsrTabMaxNum 50 // Maximal number of COM ports
#define	CSRP_BufSize 2048	   // Exchange buffer size

// COM port descriptor structure
struct TCOMPortDescriptors {
	HANDLE			hCOMPort;
	wxString		PortName;
	COMMTIMEOUTS	TimeOutS;
	DCB				dcb;
};

//==================================================================================
//============================   Module function   =================================
//==================================================================================

// COM port module initialization
void CP_COMPortInit();
// COM port module closing
void CP_COMPortClose();
// COM port opening
HFILE CP_OpenCOMPort(USHORT aCOMPortNum,int iBaudRate, char cParity, int iByteSize, int iStopBit);
// Reading from COM port
DWORD CP_ReadCOMPort(HFILE hPort, LPVOID lpBuffer, DWORD nNumberOfBytesToRead);
// Writing to COM port
DWORD CP_WriteCOMPort(HFILE hPort, LPVOID lpBuffer, DWORD nNumberOfBytesToWrite);
// Get COM port name
wxString* CP_GetCOMPortName(HFILE hPort);
// COM port closing
void CP_CloseCOMPort(HFILE hPort);

#endif // !defined(COM_PORT_H_INCLUDED_)
