//     ======================== RobotController.h ===========================
//     **********************************************************************
//     Author: Yeremeyev Dmitriy Vladimirovich *** mailto:edvmail@mail.ru
//     Last update : 23.12.2009
//     **********************************************************************


#if !defined(_RobotController_H_INCLUDED_)
#define _RobotController_H_INCLUDED_

#include "wx/wx.h"
#include "COM_port.h"

#define cKeyTotal 8
// Array structure of control keys
struct TKeyArray {
	bool Key[cKeyTotal];
};

// Control indicator class
class CIndicator : public wxStaticText
{
	wxMemoryDC mMemDC;
	wxBitmap*  mMemBmp;
	TKeyArray  mKeyArray;

public:

	// Class constructor
	CIndicator(wxWindow* parent);
	// Class destructor
	~CIndicator();

	// Handler on paint event
	void OnPaint(wxPaintEvent& event);
	// Window redrawing
	void Draw();
	// Set the actual key array
	void SetKeyArray(TKeyArray* apKeyArray);

private:
    DECLARE_EVENT_TABLE()
};

//=============================================================================================
//===================================== Class: CMainWnd =======================================
//=============================================================================================

// Main window class
class CMainWnd : public wxFrame
{
    wxPanel*    mpPanel;
	CIndicator* mpIndicator;
	HANDLE      mhCmdExchangeSection;
	HFILE       mhCOMPort;

public:
	// Class constructor
    CMainWnd();

	// Handler on "Close" event
    void OnClose(wxCloseEvent& event);
	// Handler on timer event
	void OnTimer(wxTimerEvent& event);

private:
	wxTimer m_Timer;

    DECLARE_EVENT_TABLE()
};

#endif // !defined(_RobotController_H_INCLUDED_)
